//
//  main.cpp
//  06-Textures
//
//  Created by Orlando Pereira on 06/05/15.
//  Copyright (c) 2015 Orlando Pereira. All rights reserved.
//

#include <iostream>
#include <GLUT/glut.h>

GLubyte Image[65536];
GLsizei imageWidth = 128;
GLsizei imageHeight = 128;

static void InitImage() {
    int j;
    GLubyte *img;
    
    // Create Textured Image
    img = Image;
    for (j = 0; j < 32 * imageWidth; j++) {
        *img++ = 0xff;
        *img++ = 0x00;
        *img++ = 0x00;
        *img++ = 0xff;
    }
    for (j = 0; j < 32 * imageWidth; j++) {
        *img++ = 0xff;
        *img++ = 0x00;
        *img++ = 0xff;
        *img++ = 0x00;
    }
    for (j = 0; j < 32 * imageWidth; j++) {
        *img++ = 0xff;
        *img++ = 0xff;
        *img++ = 0x00;
        *img++ = 0x00;
    }
    for (j = 0; j < 32 * imageWidth; j++) {
        *img++ = 0x00;
        *img++ = 0xff;
        *img++ = 0x00;
        *img++ = 0xff;
    }
}

static void keyboard(unsigned char key, int x, int y) {
    switch (key) {
        case 27:
            exit(0);
    }
}

void TexturesDefinition() {

    // YOUR CODE HERE!
    
    
}

static void render() {
    
    glClearColor(0.0, 0.0, 0.0, 1.0);
    glClear(GL_COLOR_BUFFER_BIT);


#if GL_EXT_abgr

#endif

    TexturesDefinition();
    glutSwapBuffers();
}

int main(int argc, char **argv) {
    
    glutInit(&argc, argv);
    glutInitWindowSize(512, 512);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
    glutCreateWindow("Textured Shapes");
    
    if (!glutExtensionSupported("GL_EXT_abgr")) {
        printf("Couldn't find abgr extension.\n");
        exit(0);
    }
    
#if !GL_EXT_abgr
    printf("WARNING: client-side OpenGL has no ABGR extension support!\n");
    printf("         Drawing only RGBA (and not ABGR) images and textures.\n");
#endif
    
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(60.0, 1.0, 0.1, 100.0);
    glMatrixMode(GL_MODELVIEW);
    
    glutKeyboardFunc(keyboard);
    glutDisplayFunc(render);
    
    InitImage();
    
    glutMainLoop();
    return 0;
}